;"650X"  PROMAX MI-650C V1.0 TASM32 version JUMULAB, Hans Otten, June 02024 checked against MI-650 ROMs
;	DEFINICI0N DE DIRECCIONES
;
;	GENERALES
;RAM: 	0000H-03EFH 	(0400H-1FFFH)
;ROM:	0F7O0H-OFFFFH	(0E000H-0F7CFH)
;I/O	OAOOOH-0A00FH
;VIA	65C22 AUXILIAR:	OA40OH-0A7FFH
;VIA	65C22 LOCAL ( 6532 )

RAIORA	.EQU	0A001H
RAIORB	.EQU	0A000H	
RAIODRA	.EQU	0A003H	
RAIODRB	.EQU	0A002H	
RAIOTLC	.EQU	0A004H	
RAIOTHC	.EQU	0A005H	;T1MERS
RAIOIER	.EQU	0A00EH	
RAIOIFR	.EQU	0A00DH	;INTERRUPT FLAG REGISTER
RAIOACR	.EQU	0A00BH	
RAIOPCR	.EQU	0A00CH	;PERIPHERAL CONTROL REGISTER

;6522 Auxiliar

PB2	    .EQU	0A400H	;PORT B
CPB2    .EQU	0A402H	;CONTROL DEL PORT 8
PA2	    .EQU	0A401H	;PORT A
CPA2	.EQU	0A403H	;CONTROL DEL PORT A
			
;	POSICIONES DE PG 0 UTILIZADAS EN RESET		
;	PERO TRANSPARENTES AL USUARIO.		
				
BASE	.EQU	02H		;ADR. DEL VALOR DE RAMTEST.
TRAML	.EQU	00H		;ADR. BAJA DEL PUNTERQ EN RAM
TRAMH	.EQU	01H		;ADP. ALTA PUNTERO EN RAM.
;
;
;				
;	RAM OE TRABAJO	(DE 0352H A 03FFH)	
;			
		.ORG	0352H	
;
REST	.BLOCK	1		;FLAG OF RESET
DISBUF	.BLOCK 	6		;BUFFER OF DISPLAY
PARL	.BLOCK	1	
PARH	.BLOCK	1	
SCR1	.BLOCK	1		;VARIOS
SCR2	.BLOCK	1	
SCR3	.BLOCK	1	
ID		.BLOCK	1		;IDENTIFIC. DE CASSETTE
MODEC	.BLOCK	1		;MODO DE TRABAJO
PRIMER	.BLOCK	1		;FLAG
PUNTO	.BLOCK	1		;PUNTOS DE ZUNA DE TRAB.
OLD		.BLOCK	1		;USO EN CASSETTE
LODIVER	.BLOCK	1		;CAS LOAD /VERIFICA
ULTEC	.BLOCK	1		;ULTIMA TECLA PULS.(FLAG)
BRKFLG	.BLOCK	1		;HAY/NO BREAK
BRKDAT	.BLOCK	1		;DATO EN MEM.SUST.PGR BRK
BRKADL	.BLOCK	1		;DIRECCION DEL BREAK
BRKADH	.BLOCK	1	
PCLR	.BLOCK	1		;REGISTROS IMAGEN
PCHR	.BLOCK	1	
SR		.BLOCK	1	
AR		.BLOCK	1	
XR		.BLOCK	1	
YR		.BLOCK	1	
PR		.BLOCK	1	
TAPDEL	.BLOCK	1		;PARAMETR0S DEL CASSETT
HSBDRY	.BLOCK	1	
TAPET1	.BLOCK	1	
TAPET2	.BLOCK	1	
ESPVEC	.BLOCK	2		;VECTOR DE MANDOS ESPEC.
BRKUS	.BLOCK	2		;VECTOR BRK DE USUARIO
IRQUS	.BLOCK	2		;UECTOR IRQ DE USUARIO
NMIUS	.BLOCK	2		;VECTOR NMI DE USUARIO
IRQVEC	.BLOCK	2		;VECTOR IRO SECUNDARIO
NMIVEC	.BLOCK	2		;VECTOR NMI SECUNDARIO
CONTA	.BLOCK	1		;C0NTADOR DE CASSETTE
TEMPO	.BLOCK	1		;TEMPORAL DE CASSETTE
;
; pagina 0
;
CHAR 	.EQU    0FDH    ;TEMPORAL DE CARACTER
CURAD	.EQU	0FEH	;PUNTERO USD GENERAL

;**********************************************************
;
; MARCA PARA RECONOCER SI SE TRATA DEL MI-650C
; 0 DE VERSIONES ANTERIORES
;
		.ORG	0E000H 	;POSICION DE LA MARCA
MARCA	.BYTE 	0AAH
;
;**********************************************************
;**********************************************************
;
;	ZONA D PATCH PARA EL MONITOR DEL MI-650C
;	DEFINIDO PAPA MANTENER CONSTANTES LAS DIRECCIONES
;	DE LAS SUBRUTINAS DE MEMORIA UTILIZADAS EN
;	LOS OTROS MODELOS DE MI-650.
;
		.ORG	0F100H
;
;	ADAPTACION DEL SISTEMA DE LECTURA DE DATOS
;	DEL CASSETTE DEBID0 AL CAMBIO 6532 POR 65C22.
;	BASICAMENTE SUSTITUYE EL DIUISOR DE 8 BITS
;	DEL CIRCUITO INICIAL POR UNO DE 16 BITS EN EL
;	65C22.
;
M_PATCH1		
		LDA		#03H		;DIV PER 8 PER TRIPLE SHIFT
		STA		CONTA		;DEL CCONTENIDO CONTADOR 16 BITS
		LDA		RAIOTHC	
		AND		#07H	
		STA		TEMPO	
		LDA		RAIOTLC
LOOPA		
		CLC	
		LSR		TEMPO 		;3 x SHIFT A TRADES DEL 'CY'
		ROR		A
		DEC		CONTA
		BNE		LOOPA
		STY		RAIOTLC 	;CARREGAR BYTE LOW DEL TIMER 1
		LDY		#07H		;BYTE ALT TIMER 1
		STY		RAIOTHC 	;DISPAPAR EL TIMER 1
		CLC	
		ADC		HSBDRY
		RTS	
;**********************************************************
;		
;	INICIALIZA EL 65C22 DE I/O AUXILIAR	
;
M_PATCH2			
;		
		INX	
		STX		RAIODRA
		LDA		#00001111B
		STA 	RAIODRB
		LDA 	#00111111B
		STA		RAIODRB
		LDA		#00H
		STA		RAIOACR
		STA		RAIOPCR
		LDA		#7FH
		STA		RAIOIER
		STA 	RAIOIFR
		RTS	
;		
;**********************************************************
;
;	NUEVO MENSAJE DE SALIDA Y CONTROL LED's	
;			
M_PATCH3
		LDA		#0FFH		;PROG. PORT B DE SALIDA
		STA		CPB2
		LDA		#00H
		STA 	CPA2   		;PORT A DE ENTRADA  	
		STA		DISBUF
		LDA		#7DH		;6
		STA		DISBUF+1
		LDA		#6DH		;5
		STA		DISBUF+2
		LDA		#3FH		;0
		STA		DISBUF+3
		LDA		#39H		;C
		STA		DISBUF+4
		LDA		#00H ;
		STA		DISBUF+5
		SEC	
		LDA		#0			;ENCIENDE LEDs
LED			
		ROL		A
		STA   	PB2
		PHA		
		PHP		
		LDY		#10H		; TEMPORIZACION
		JSR		ESPER+2	
		PLP		
		PLA		
		BCC		LED	
		LDA		PA2			;TEST DE MICROCONMUTADORES
		EOR		#0FFH		;INVERTIR (SW-0N == LED-ON)
		STA		PB2	
		RTS		
;**********************************************************
;**********************************************************
;
;	ZONA DE ROM RESERVADA PARA LOS PROGRAMAS DE
;	PRACTICAS DEL CAPITULO 6 DEL LIBRO.
;
;	.ORG	0F3CAH
;
;**********************************************************
;**********************************************************
;
;	ZONA DE MEMORIA DEL PROGRAMA MONITOR
;

	.ORG 	0F7D0H

						;	BUCLE DE REPOSO
						;	SITUACION DE ESPERA DE INSTPUCC1ONES
						;	ENTRADA NORMAL
						;	SACA LINEAS EN DISPLAY Y ESPERA

;
MONITR
		CLC
		BCC 	START
;
						;	ENTRADA DE ERROR
						;	SACA TEXTO "Err" Y CODIGo EN ACC
ERROR		
		SEC		
						;	ENTRADA COMUN
START 	LDX 	SR		;NO ALTERES EN TRACE
		TXS				;INICIALIZA STACK
		CLD				;NO DECIMAL
		BCS 	STRT2	
NORMAL		
		LDX 	REST	
		BEQ 	NORM1	;NO
SALUDO		
		JSR 	CLRDIS	;BORRA DISPLAY
		JSR 	M_PATCH3	;NUEVO MENSAJE
		DEC 	REST	
		JMP 	NORMAL	;TREURE GUIONES
	
		.ORG	0F7FCH	;NO VARIAR ADR.
;	
NORM1
		LDA		#40H	;CODIGO DE -
		LDX		#6H
STRT1	STA		DISBUF-1,X
		DEX	
		BNE		STRT1
		BEQ		STRT3 	;A BUCLE
;			
STRT2
		PHA				;SALVA CODIGO
		JSR		CLRDIS 	;BORRA DISPLAY
		LDA		#79H	;E
		STA		DISBUF
		LDA		#50H	;r
		STA		DISBUF+1
		STA		DISBUF+2
		PLA	
STRT21	
		JSR		OUTDAT 	;CODIGO DE ERROR

				;BUCLE DE ESPERA EN REPOSO

STRT3		
		LDA		#0
		STA		PUNTO 	;B0RRA PUNTOS
		JSR		GETKEY 	;OBTEN TECLA
		BCC		STRT3 	;NO HAY ESPERA
		CMP		#0EH 	;BORRA ERROR CON 'FIN'
		BEQ		MONITR
		CMP		#0EH 	;VALIDA?
		BCC		STR3	;SI
		JSR		ESPEC 	;NO, SALTO VECTORIZADO
		JMP		START 	;Y RETORNO

				;EJECUCION DE INSTRUCCIONES DE AMPLIACION

STR3
		JSR		EJEC
		JMP		START	;Y RETORNO

				;SALTO INDIRECTO DE EJECUCION DE AMPLIACIONES

ESPEC	
		JMP		(ESPVEC)
				;EJECUCION OE FUNCIONES

EJEC

		JSR		CLRDIS 	;BORRA DISPLAY
		BEQ		EJEC0
		JMP		EJEC1
		
				;INSPECCIONA/ALTERA MEMORIA
;		
EJEC0
		LDA		#06H
		JSR		INDIC	;SACA INDICADOR 'ad'
		LDA		CURAD	;PASA ULTIMA DIRECCION
		STA		PARL	;USADA EN REFERENCIAS
		LDY		CURAD+1	;A MEMORIA
		STY  	PARH
		JSR  	OUTADD  ;SACA A DISPLAY
		JSR  	GETADD  ;OBTEN DIRECCION
		LDA		PARL	
		STA		CURAD	;TOMA DIRECTION
		LDA		PARH	
		STA		CURAD+1	
		LDA		#000011B	
		STA		PUNTO	;FIJA PUNTOS
				
M1			
				
		LDY		#00H	
		LDA		(CURAD),Y	
		STY		PRIMER	
		STA		PARL    ;SALVA VALOR
M1A		JSR		OUTDAT	; EL DATO
M1B		JSR		GETKEY	;TOMA TECLA
		BCS		M1C		;HAY, PROCESA
		LDY		PRIMER	;INTRODUCIDO DATO?
		BEQ		M1		;NO SACA DATO PRES. EN CURAD
		BNE		M1B		;SI SACA DATO INTRODUCIDO
M1C
		CMP		#12H	;FINAL?
		BNE		M2	
		CLC				;RETORHO
		RTS		
M2
		BCS		M1B		;IGNORA OTRAS
		CMP		#10H	;HEX?
		BCC     MHEX	;SI
		PHP				;SERA '+' O '-' SALVA
		LDA		PRIMER	
		BEQ		M3		;IGNORA SI NO HAY DATO NUEVO
		LDA		PARL	
		LDY		#00H	
		STA		(CURAD),Y 	;SALVA EN MEMORIA	
		CMP		(CURAD),Y	;HECHO?	
		BEQ		M3		;S1
		PLA				;NO AJUSTA STACK
		JMP		M1      ;Y REPITE
M3
		PLP			;ALTERA DIRECCION
		BNE		M4	
		INC		CURAD	;AUMENTA
		BNE		M6	
		INC		CURAD+1	
		JMP		M6	
M4
		LDA		CURAD	;DISMINUYE
		BNE		M5	
		DEC		CURAD+1	
M5			
		DEC		CURAD	
M6
		LDA		CURAD	
		LDY		CURAD+1	
		JSR		OUTADD	;SACA DIRECCION
		JMP		M1		;Y REPITE
MHEX			
		JSR		PACK	;EMPACA
		JMP		M1A		;Y REPITE
EJEC1			
		CMP		#01H	
		BNE		EJEC2	
			
				;SALIDA	A PROGRAMA DE USUARIO
			
		LDA		#7H	
		JSR		INDIC   ;INDICADOR 'GO'
		LDA		PCLR	;PASA DEFAULT
		STA		PARL	
		LDY		PCHR	
		STY		PARH	
		JSR		OUTADD	
		JSR		GETADD	
		LDA		PRIMER	;HAY PARAMETRO?
		BEQ		GO		;NO, USA ANTIGUO
		LDX		#0FFH	
		TXS		
		LDA		#(MONITR-1)/256	
		PHA	
		LDA		#(MONITR-1)&00FFH	
		PHA		
		LDA		PARL	;TOMA DIRECT. DE ACCION
		STA		PCLR	
		LDA		PARH	
		STA		PCHR	
		JMP		GO1	
GO   	LDX		SR		;PASA REGISTRO DE USUARIO
		TXS		
GO1		
		LDA		PCHR	
		PHA		
		LDA		PCLR	
		PHA		
		LDA		PR	
		PHA		
		LDA		AR	
		LDX		XR	
		LDY		YR	
		RTI				;A EJECUCION
EJEC2			
		CMP		#0CH	
		BNE		EJEC3	
		
				;CONTINUA EL TRAZADO DE PROGRAMA	
				;EQUIVALENTE A PULSAR 'C Y 'FIN'	

		JMP		GO	
EJEC3
		CMP     #0BH
		BNE     EJEC4

				;FIJA BREAKPOINT

		LDA     BRKFLG  ;HAY YA ?     
		BEQ     BS1     ;NO
		LDA     #05H
BSER	
		SEC             ;ERROR          
		RTS
BS1
		LDA     #08H
		JSR     INDIC   ;INDICADOR 'BR'
		JSR     GETADE  ;OBTEN DIRECCION        
		LDA     PARL        
		STA     CURAD
		LDA     PARH
		STA     CURAD+1 ;PASA DIRECCION
		LDY     #00H
		LDA     (CURAD),Y       ;DATO EN MEMORIA
		TAX
		TYA
		STA     (CURAD),Y       ;PON BREAK
		CMP     (CURAD),Y       ;ECHO?
		BEQ     BS2             ;SI
		TXA
		STA     (CURAD),Y
BSER1
		LDA     #03H
		BNE     BSER 	;ERROR DE NO MEMORIZADO
BS2
		STX     BRKDAT  ;SALVA EN MEMORIA           
		LDA     CURAD
		STA     BRKADL
		LDA     CURAD+1
		STA     BRKADH
		INC     BRKFLG	;PON FLAG
BSSAL	
		CLC
		RTS    			;SALIDA OK        
EJEC4
		CMP     #09H
		BNE     EJEC5

						;BORRA BREAKPOINT

		LDA     BRKFLG	;HAY FLAG?                
		BNE     BC1     ;SI
BCER	
		LDA     #04H    ;NO ERROR
		BNE     BSER
BC1	 	LDA     BRKADL
		STA     CURAD
		LDA     BRKADH
		STA     CURAD+1	
		LDY		#00H
		LDA		BRKDAT
		STA		(CURAD),Y
		CMP		(CURAD),Y
		BNE		BSER1
		STY		BRKFLG  ;QUITA EL FLAG
		JMP		OFF	  	;TEXTO Y FINAL
		
EJEC5   CMP		#0AH
		BNE     EJEC6
	
				;MUESTRA LA D1RECCION DEL BREAK ACTUAL
			
		LDA		BRKFLG	;HAY
		BEQ		BCER  	;NO,ERROR
		LDA		#09H
		JSR		INDIC   ;INDICADQR "b?"
		LDA		BRKADL
		LDY		BRKADH
		JSR		OUTADD 	;SACA LA DIRECCION
		JMP		STRT3 	;Y FINAL
EJEC6	
		CMP     #08H
		BNE		EJEC7
		
				;PROTEGE CONTRA ESCRITURA RAM #400H-#7FF (AMPLIAC.)

		LDA     RAIORB
		EOR		#00010000B
		STA		RAIORB      ;BASCULA LINEA
		AND		#00010000B	;MIRA VALOR ACTUAL	

		BEQ		PROOF
		JMP		ON	 	;INDICADOR DE on'
PROOF
		JMP		OFF	    ;INDICADOR DE 'of'
EJEC7
		CMP		#02H
		BNE		EJEC8
			
				;LISTA/ALTERA LOS REGISTROS
	
		LDA		#00H
RB
		STA		SCR1
		JSR		CLRIND 	;SACA NOMBRE
		LDA		SCR1    ;TOMA PUNTERO
		TAX	
		CPX		#00H	;EN P.C.
		BNE		R1	 	;NO
		LDA		PCLR    ;PASA DATOS
		STA		PARL
		LDY		PCHR
		STY		PARH
		JSR		OUTADD 	;SACA VALOR ACTUAL
		LDA		#01H
		STA		MODEC	;4 BY
		JSR     GETP3 	;OBTEN DATOS
		PHA  			;SALVA TECLA
		LDA     PARL    ;CON NUEVO VALOR
		STA     PCLR
		LDA     PARH
		STA     PCHR
		JMP     R2    	;Y SIGUE
R1
		LDA     SR-1,X  ;RESTO DE REGISTROS
		STA     PARL
		JSR     OUTADH
		LDA     #00H
		STA     MODEC   ;2BY
		JSR     GETP3   ;OBTEN DATOS
		PHA
		LDX     SCR1
		LDA     PARL
		STA     SR-1,X  ;NUEVO VALOR
R2
		PLA       		;TOMA ULTIMA TECLA
		CMP     #12H
		BNE     R3
		CLC
		RTS      		;SALIDA
R3
		LDX     SCR1
		CMP     #10H
		BNE     R4
		INX             ;AUMENTA
		CPX     #06H
		BCC     R5
		LDX     #00H
		BEQ     R5
R4
		DEX           	;DISMINUYE
		BPL     R5
		LDX     #05H
R5
		TXA
		JMP     RB      ;REPITE
;	
EJEC8	
		CMP     #03H
		BNE     EJEC9

						;MEMORIZA VECTOR
			
		LDA     #0AH
		JSR     INDIC	;INDICADOR 'Vd'
		JSR     GETADE  ;OBTEN DATO
		LDA     PARL
		STA     SCR1    ;SALVA
		LDA     PARH
		STA     SCR2
		LDA     #0BH
		JSR     CLRIND  ;BORRA EL INDICADOR 'VA'
		JSR		GETADE
		LDA		PARL
		STA		CURAD
		LDA		PARH
		STA		CURAD+1
		LDY		#00H
		LDA		SCR1	;PASA HECTOR
		STA		(CURAD),Y
		CMP     (CURAD),Y		;HEMORIZADO?
		BNE		VECER	;NO ERROR
		INY	
		LDA		SCR2
		STA		(CURAD),Y
		CMP		(CURAD),Y
		BNE		VECER 	;ERROR
		CLC	
		RTS	          	;RETORNO
VECER	
		LDA		#03H 	;ENTRADA DE NO MEMOORIZA
		SEC	          	;FLAG DE ERROR
		RTS	
EJEC9
		CMP     #0DH
		BNE		EJEC10

				;CALCULO DE OFFSET EN INSTRUCCION DE RAMIFICACION
	
		LDA		#14H
		JSR		INDIC 	;TEXTO 'ca'
		JSR		GETADE	;OBTEN DIRECCION INICIAL Y FINAL
		LDX		#0FFH   ;

		TXS        		;INICIA STACK
		INX	
		STX		PUNTO	;BORRA PUNTOS
		INC		PARH    ;RESULTADO=FINAL-INIC.-2
		CLC	
		LDA		PARL
		SBC		PARH
		JMP		STRT21 	;PRESENTA DAT05 Y FINAL
EJEC10
		CMP		#07H
		BNE		EJEC11
		
				;BASCULA MOTOR DEL CASSETTE
	
		LDA		RAIORB
		EOR		#00100000B
		STA		RAIORB
		AND		#00100000B		;TOMA VALOR ACTUAL
		BEQ		BASOF	    	;OFF
		JMP		ON
BASOF
		JMP     OFF

		
EJEC11
		CMP     #04H			
		BEQ		SCE
		JMP		EJEC12		
				
				;SALVA DATOS EN CASSETTE		
				;OBTEN PARAMETROS		
SCE
		LDA		#0CH		
		JSR		INDIC  	;IDENTIFICACION 'id'		
		JSR		GETPAR 	;OBTEN NUMERO		
		LDA		PARL		
		STA		ID		
		LDA		#0DH		
		JSR		CLRIND 	;DIRECCION ENICIAL 'di'		
		JSR		GETADD		
		LDA		PARL		
		STA		CURAD		
		LDA		PARH		
		STA		CURAD+1	
		LDA		#0EH		
		JSR		CLRIND  ;DIRECCION FINAL	
		JSR		GETADD	
		INC		PARL		
		BNE		CS0
		INC		PARH  	;AUMENTA
	
				;SALVA DATOS	
	
CS0
		JSR		STARTC		
		LDA		TAPDEL	
		STA		PRIMER	;NUMERO DE SYNC/256
CS1
		LDA		#16H  	;SYN	
		JSR		OUTCSC 	;SACA SIN CHECKSUM	
		DEY			
		BNE		CS1	
		DEC     PRIMER	
		BNE		CS1	
		LDA		#02AH
		JSR		OUTCSC		
		LDA		ID		
		JSR		OUTCSC	;IDENTIFICACION	
		LDA		CURAD   ;DIR INICIAL		
		JSR		OUTCCC	
		LDA		CURAD+1	
		JSR		OUTCCC	
		LDA		PARL    ;DIR FINAL
		JSR		OUTCCC	
		LDA		PARH	
		JSR		OUTCCC
CS2
		LDA     CURAD   ;FINAL DE TRANSMISION
		CMP     PARL
		BNE		CS3	    ;NO
		LDA		CURAD+1
		CMP		PARH	
		BNE		CS3     ;NO

						;FINAL DE TRANSMISION
		LDA     #2FH    ;MARCA
		JSR     OUTCSC
		LDA     SCR1    ;CHECKSUM
		JSR     OUTCSC
		LDA     SCR2
		JSR     OUTCSC
		CLC
		JMP     LCOU    ;FINAL

				;TRANSMITE DATOS

CS3
		LDY     #0H
		LDA     (CURAD),Y
		JSR     OUTCCC
		INC     CURAD	;AUMENTA VECTOR
		BNE     CS2
		INC     CURAD+1
		JMP     CS2
		
EJEC12	
		
		CMP     #05H
		BNE     EJEC13

;       CARGA DATOS DEL CASETTE
;
		LDY     #00H	;FLAG DE LOAD
		BEQ     LCE     ;Y COMUN

				;VERIFICA DATOS SALVADOS EN EL CAsSETTE

EJEC13
		LDY     #80H    ;FLAG DE VERIFICACION

				;PARTE COMUN DE CARGAR VERIFICAR DATOS

LCE
		STY     LODIVER
		LDA     #0CH
		JSR     INDIC	;TEXTO 'id'
		JSR     GETPAR 	;OBTEN IDENTIFICADOR
		LDA     PARL
		STA     ID
		CMP     #0FFH
		BNE     LCL     ;NO CARGA
		LDA     #0DH
		JSR     CLRIND  ;TEXTO 'di'
		JSR     GETADD  ;NUEVA DIR INICIAL
		
		LDA     PARL	
 

		STA     CURAD
		LDA     PARH	
		STA		CURAD+1	
		LDA		#0EH	
		JSR		CLRIND	;TEXTO dF'
		JSR		GETADD	;NUEVA DIR. FINAL
		INC		PARL	;AUMENTA FINAL
		BNE		LCL	
		INC		PARH	
			
				;CARGA DATOS SINCRONIZA	
		
LCL
		JSR		STARTC	
		ORA		#03H	;SELECC DIGITO IZQDO
		STA		RAIORB	
		LDA		#0FFH
		STA		RAIODRA ;RA A SALIDAS
LC1
		JSR     SYNC 	;SINCRONIZA
LC2
		JSR		GETCSC	
		CMP		#2AH	
		BEQ		LC21	;SI
		CMP		#16H	;SYN?
		BNE		LC1	    ;NO
		BEQ		LC2
				;ENCONTRADOS DATOS
LC21
		ASL		LODIVER	;TOMA BIT?
		ROR		A	
		STA		MODEC	
		JSR		GETCSC	
		STA		RAIORA	;SACA 'id' AL DISPLAY
		CMP		ID
		BEQ		LC4	 	;COINCIDE
		LDA		ID	
		BEQ		LC4		;PRIMERO ENCONTRADO
		CMP		#0FFH
		BEQ		LC3	 	;ESTE CON NUEVA DIRECCION
		LDA		MODEC	
		ORA		#40H	
		STA		MODEC 	;FLAS DE IGNORAR
		BNE		LC4	   	;Y SIGUE
			
				;DIRECCIONES SUMINISTRADAS FOR EL USUARI0	

LC3
		JSR		GETCCC	;PUNTEA A DATOS
		JSR		GETCCC	
		JSR		GETCCC	
		JSR		GETCCC	
		JMP		LC5	

LC4
						;DIRECCIONES EN ClNTA
		JSR		GETCCC	;DIR INICIAL
		STA		CURAD
		JSR		GETCCC		
		STA		CURAD+1
		JSR		GETCCC 	;DIR FINAL
		STA		PARL
		JSR		GETCCC
		STA		PARH
	
				;LECTURA DE DATOS
;	
LC5
		JSR		GETCSC
		LDX		CURAD 	;FINAL?
		CPX		PARL
		BNE		LC6
		LDX		CURAD+1
		CPX		PARH
		BEQ		LCF		;FINAL
LC6
		JSR		AJCK	;AJUSTA CHECKSUM
		LDY		#00H
		BIT		MODEC
		BVS		LC8	    ;IGNORA
		BMI		LC7	    ;VERIFICAR
		STA		(CURAD),Y		;SALVA DATO
LC7
		CMP		(CURAD),Y		;VERIFICA
		BEQ		LC8		;OK
		LDA		#3
		BNE		LCER
LC8
		INC		CURAD	;AUMENTA VECTOR
		BNE		LC5 	;Y REPITE
		INC		CURAD+1
		JMP		LC5
		
				;FIN DE DATDS

LCF		
		CMP     #2FH	;MARCA DE FINAL ?
		BEQ     LC9  	;SI
		LDA     #00H 	;NO, ERROR
		BNE     LCER
LC9
		JSR     GETCSC	;MIRA CHECKSUM
		CMP     SCR1
		BNE     LC10  	;MAL
		JSR     GETCSC
		CMP     SCR2
		BEQ     LCOR
LC10    
		LDA     #02H   	;ERROR
LCER    
		SEC          	;FLAG DE MAL
		BCS     LCSA

LCOR
		CLC             ;FLAG DE OK
LCSA
		BIT     MODEC 	;PUENTEANDO?
		BVC     LCOU    ;NO
		JMP     LCL     ;SI, REPITE
LCOU
		PHA
		LDA     RAIORB
		AND     #11011111B  	;PARA MOTOR
		ORA     #0FH 	;SELECCIONA A REPOSO
		STA     RAIORB
		PLA
		RTS        		;FINAL
		
				;SUBRUTINAS DE CASSETTE

STARTC	
		LDY		#00H	;INICIAL1ZA
		STY		SCR1	;CKSUM
		STY		SCR2
		LDA		#20H	
		ORA		RAIORB	;MOTOR ON
		AND		#0F0H	
		STA		RAIORB	
		RTS		        
		
				;SINCRONIZA LECTURA

SYNC
		LDA     #6DH  	;SACA S' A DISPLAY
		STA     RAIORA
		LDA     MODEC
		ORA     #40H
		STA     MODEC
 
SY1
		JSR     SYNBIT
		ROR     CHAR
		LDA     CHAR
		CMP     #16H
		BNE     SY1		;ESPERA A 'SYN'
		LDX     #0AH       
SY2  
		JSR     GETCSC	;ESPERA 10 'SYN'
		CMP     #16H
		BNE     SY1
		DEX
		BNE     SY2
		STX     RAIORA	;BORRA 'S'
		RTS

				;SACA BYTE A CASSETTE

OUTCCC			
		JSR		AJCK	;CON CHECKSUM
OUTCSC			
		LDX		#09H 	;SIN CHECKSUM
		STY		SCR3	
		STA		CHAR	
		LDA		RAIORB	;OBTEN NIVEL
OUTCB1	
		LSR		CHAR
		EOR		#09H
		STA		RAIORB  ;INVIERTE NIVEL
		LDY		TAPET1
OUTC1		
		DEY	
		BNE		OUTC1	;RETARDO       
		BCC		OUTCN
		EOR		#09H 	;BASCULA SI BIT=1
		STA		RAIORB
		
			;SEGUNDO SEMICICLO
OUTC2		
		LDY		TAPET2
OUTC3		
		DEY	
		BNE		OUTC3
		DEX	
		BNE		OUTCB1	;OTRO BIT
		LDY		SCR3
		RTS	
OUTCN		
		NOP	
		BCC		OUTC2

				;LECTURA DEL BYTE DE CINTA

GETCSC
		STX     SCR3
		LDX     #08H
		JSR     GETCTR
		BCS     GETC3
GETC1
		JSR     GETCTR
		BCC     GETC2
		JSR     GETCTR
		SEC
GETC2
		ROR     CHAR
		DEX
		BNE     GETC1
		LDA     CHAR	;FIN DE TOMA
		LDX     SCR3
		RTS
GETC3
		BIT     MODEC
		BVS     GETC3-4
		PLA
		PLA
		LDA     #01H    ;ERROR EN LOAD 
		JMP     LCER
		
				;LECTURA DEL BYTE DE CINTA CON CHECKSUM

GETCCC
		JSR	GETCSC

		
			;AJUSTA CHECKSUM CON VALCR EN ACUMULADOR

AJCK		
		TAY
		CLC	
		ADC		SCR1
		STA		SCR1
		BCC		AJCK1
		INC		SCR2
AJCK1
		TYA	
		RTS	
				;OBTEN BIT DURANTE SINCRON1ZACION

SYNBIT
		JSR		GETCTR
		BCS		GETCTR
		RTS	

			;OBTEN TIEMPO DE TRANSICION

GETCTR		
		LDY		#0FFH
GETCTR1
		LDA		RAIORB
		AND		#40H
		CMP		OLD
		BEQ		GETCTR1
		STA		OLD
		JMP		M_PATCH1	;SALTA A MODIF. DEL MI650C
;        
;	ESTA MODIFICACION INCLUYE EL RETURN.	
;		
;****************************************************************************
				;SUBRUTINAS DE SALIDA A DISPLAY
				;SACA 4 CARACTERES EN ADDRESS
				;ENTRADA ACC, PARTE BAJA EMPACADA
				;R(Y) PARTE ALTA EMPACADA

		.ORG	0FD22H	;AJUSTAR DIRECC. ANTIC MONITOR.
OUTADD		
		PHA	
		TYA	
		LDX		#00H
		JSR		OUTACC	;SACA PARTE ALTA
		PLA	
		JMP		OUTACC	;SACA PARTE BAJA
			
	
				;SACA DOS CARACTERES EN ADRESS (DIGITO 0 Y 1)
				;ENTRADA ACC DATO EMPACADO
	
OUTADH
		LDX     #00H
		JMP     OUTACC	;SACA
		
				;SACA DOS CARACTERES EH DATOS
				;ENTRADA ACC DATO
OUTDAT
		LDX     #04H
	  
				;SACA ACC A DISPLAY COMO LOS CARACTERES, A
				;PARTIR DEL DIGITO INDICAOO FOR R(X)
				;INCREMENTANDO ESTE
OUTACC		
		PHA     		;SALVA DATO
		LSR		A
		LSR		A
		LSR		A
		LSR		A
		JSR		OUTACH	;ALTO
		PLA	
;		
;       SACA BITS 0-3 DE ACC COMO UN CARACTER HEX
;		
OUTACH		
		AND	#0FH
		TAY	
		LDA		SEGMTB,Y	;CODIGO DE SEGMENTOS
		STA		DISBUF,X	;COLOCA EN buffer
		INX	                ;AUMENTA LUGAR
		RTS	

			;BORRA DISPLAY
;		
CLRDIS		
		PHA	        	;SALVA ACUMULADOR
		LDA		#00H
		LDX		#06H
CLRD1	
		STA		DISBUF-1,X
		DEX	
		BNE		CLRD1
		PLA	
		RTS	

				;SACA TEXTO CON BORRADO PREVIO
		
CLRIND	
		JSR		CLRDIS
		
				;SACA INDICADOR DE 0PERACI0N A DISPLAY
				;EL TEXTO (2 CARACTERES) EN LA ZONA DE
				;EN ACC ESTA EL CODIGO DEL TEXTO
	
INDIC	
		ASL		A		;2
		TAY         	;PUNTERO
		LDA		MENTAB,Y
		STA		DISBUF+4
		LDA		MENTAB+1,Y
		STA     DISBUF+5
		RTS 

				;SACA TEXTO 'ON' TEMPORALMENTE

ON
		LDA     #12H
		JSR     CLRIND
		JMP     ESPER	;ESPERA FINAL
	
				;SACA TEXTO 'OF' TEMPORALMENTE
	
OFF	
		LDA     #13H
		JSR     CLRIND
;
;       HAZ RETARDC DE APRDX, 8 seg.
;
ESPER	
		LDY		#64H	
		STY		SCR1	;CONTADOR
ESPER1			
		JSR		REFDIS	;PRESENTA DATOS
		DEC		SCR1	
		BNE		ESPER1	
		CLC		
		RTS		

				;HAZ RETARDO DE APROXIMADAMENTE 1.5 mseg

DELAY	
		LDX     #0FFH
		DEX
		BNE     DELAY+2
		RTS
						;******************************
						;SUBRUTINAS DE ENTRADA DE DATOS
						;******************************


				;D1RECCION HASTA FIN ,SI TECLA NO HEX 0 NO
				;HAY DATOS,ERROR

GETADE		
		LDA		#1H
		STA		MODEC
		BNE		GETP1

				;DIRECCION HASTA FIN SI TECLA NO HEX, ERROR

GETADD		
		LDA		#1H
		STA		MODEC
		BNE		GETP2

				;PARAMETRO (2BY) HASTA FIN SI TECLA NO HEX
				;O NO HAY DATOS ERROR


GETPAR		
		LDA		#0H
		STA		MODEC
GETP1		
		JSR		GETP2
		LDA		PRIMER	;HAY DATOS?
		BEQ		GAT
		RTS	            ;OK
GAT		
		LDA		#6H
		JMP		ERROR	;ERROR
GETP2		
		JSR		GETP3
		CMP		#12H    ;FINAL?
		BNE		GAT2
		RTS	            ;OK
GAT2		
		LDA		#7H
		JMP		ERROR   ;NO HEX

		;OBTEN STRING DE CARACTERES HASTA TECLA
		;NO HEX. EMPACANDO EN PARH. PARL SEGUN
		;SEA EL VALOR DE MODEC SACA 2 o 4 .BYTES
		;A DISPLAY
		
GETP3		
		LDA		#110000B
		LDY		MODEC
		BEQ		GETP31
		LDA		#111100B
GETP31		
		STA		PUNTO  	;PUNTOS INDICATIVOS
		LDA		#0H
		STA		PRIMER 	;FLAG
GETP32	
		JSR		GETKEY	;OBTEN TECLA
		BCC		GETP32  ;NO HAY
		CMP		#10H	;HEX?
		BCC		GAT3
		RTS	           	;NO HEX
GAT3		
		JSR		PACK	;EMPACA
		LDX		MODEC
		BEQ		GETP33
		JSR		OUTADD  ;SACA 4 BYTES
		JMP		GETP32  ;Y REP1TE
GETP33		
		JSR		OUTADH 	;SACA 2 BYTES
		JMP		GETP32	;Y REPITE
;		
;       EMPACA VALOR HEX EN ACC EN PARH, PARL
;       SI FRIMERA VEZ, HAZ 0 PREVIAMENTE PARH,PARL
;	
PACK
		LDY		PRIMER
		BNE     PACK1
		STY     PARH	;BORRA
		STY     PARL       
		INC     PRIMER  ;IMPIDE MAS VECES
PACK1	
		LDY     #4H
		ASL     PARL
		ROL     PARH
		DEY
		BNE     PACK1+2
		ORA     PARL 	;Y ANADE NUEVO VALOR
		STA     PARL
		LDY     PARH
		RTS
				;**************************	
				;MANEJO DE DISPLAY Y TECLAO
				;**************************

				;SIMULTANEAMENTE PRE5ENTA LOS DATOS EN DISBUF
				;Y HACE SCANNER DE TECLAO
				;SI NO HAY TECLA PULSADA, CY=0
				;SI HAY TECLA CY=1 Y CODIGO EN ACC

GETKEY
		LDA		PUNTO	;COLOCA PUNTOS
		STA		CHAR	
		LDX		#5H	
GEK0			
		LDA		DISBUF,X	
		LSR		CHAR	
		BCC		GEK1	
		ORA		#080H	;HAY
		BNE		GEK2	
GEK1			
		AND		#7FH	;N0 HAY
GEK2			
		STA		DISBUF,X
		DEX		
		BPL		GEK0	;HASTA FINAL
		JSR		REFDIS  ;SACA DISPLAY Y MIRA TECLAO
		BCS		GEK3	;PULSADA
GEKNT			
		LDA		#0H	
		STA		ULTEC	;BDRRA FLAG
GEKNT1			
		CLC		
		RTS		
GEK3			
		CMP		ULTEC	;SIGUE PULSADA?
		BEQ		GEKNT1  ;SI, IGNORA
		LDX		ULTEC	;SE HABIA SOLTADO?
		BNE		GEKNT1	;NO; IGNORA
		STA		ULTEC	;SI SALVA NUEVA
		JSR		REFDIS	;REPITE PROCESO
		BCC		GEKNT   ;NO SE MANTIENE
		CMP		ULTEC	;LA MISMA?
		BNE		GEKNT1  ;NO, IGNORA
		SEC             ;FLAG DE QUE HAY TECLA
		LDA     ULTEC
		AND     #7FH    ;QUITA FLAG
		RTS             ;Y SALIDA

				;REFRESCO DEL DISPLAY

REFDIS	
		LDA     RAIORB
		AND     #0F0H
		ORA     #8H
		TAY          	;ULTIMO DIGITO
		LDX     #5H    	;NUMERO DE DIGITOS
		LDA     #0FFH
		STA     RAIODRA	;A SALIDAS
REDI1	
		LDA     #0H
		STA     RAIORA  ;BORRADO
		STY     RAIORB  ;SELECCIONA DIGITO
		LDA     DISBUF,X          ;TOMA CARACTER
		STA     RAIORA  ;SACA SEGMENTOS
		TXA
		PHA
		JSR     DELAY
		PLA
		TAX
		DEY
		DEX
		BPL     REDI1	;REPITE
		STY     RAIORB	;DESELECCIONA
		LDA     #0H
		STA     RAIODRA	;A ENTRADAS
	
				;SCANNER DE TECLADO
				;SALIDA CY=1:TECLA PULSADA

SCAN
		LDX     #2H
		LDA     RAIORB
		AND     #0F0H
		ORA     #2H
		TAY
SCAN1	
		STY     RAIORB	;SELECCIONA COLUMNA
		LDA     RAIORA
		EOR     #0FFH
		BNE     SCANH 	;HAY TECLA
		DEY
		DEX
		BPL     SCAN1
		CLC
		RTS           	;NO HAY TECLA

				;HAY TECLA, DECODIFICA

SCANH	
		PHA
		TXA		
		ASL		A	
		ASL		A	
		ASL		A	
		TAX		
		PLA		
SCAN2			
		LSR		A		;OBTEN BIT
		BCS     SCANF	;FINAL
		INX		
		BNE		SCAN2	;SIEMPRE
SCANF			
		TXA		        ;TOMA CODIGO
		ORA		#80H	;PON FLAG
		SEC		
		RTS		
			
				;ENTRADA DE IRQ/BRK	

IRQBRK			
		STA		AR	
		PLA		
		PHA				;OBTEN STATUS
		AND		#10H    ;BRK
		BNE		BRK	
		LDA		AR	
		JMP     (IRQUS) ;A IRQ DE USUARIO
BRK		
		LDA		AR	
		JMP		(BRKUS)	;A BRK DE USUSARIO
			
				;ENTRADA DE NMI	
				;Sl PROCEDE DE STOP, VE A MONITR	
				;SI DE ELEMENTO EXTERNO A USUARIO	
			
NMIENT			
		BIT		RAIORB	;MIRA SI PROC.DE BRK LOCAL
		BMI		NMISTP	
		JMP		(NMIUS) ;A NMI DE USUARIO
			
				;ES TECLA DE STOP
			
NMISTP			
		SEC		
		BIT		NMISDA	
		JSR		SAVREG	;SALVA LOS REGISTROS
		JSR		DELAY	;ANTl-REBOT. DE TEC. STOP
		LDA		RAIORB	;PULSA LINEA DE CLEAR
		PHA		
		AND		#0F0H	
		ORA		#9H	
		STA		RAIORB	
		PLA		
		STA		RAIORB
		JMP     MONITR	;A MONITOR
NMISDA
		.BYTE	40H

		
				;*************************************
				;ENTRADA DE INTERRUPCIONES DEL SISTEMA
				;*************************************

				;SACA PC E INDICADORES A DISPLAY
				;BRK

BRKSIS	
		CLC	
		CLV	
		JSR		SAVREG
		LDA		#0FH
		BNE		INTIND
		

				;IRQ

					
IRQSIS	
		SEC	
		CLV	
		JSR		SAVREG
		LDA		#10H
		BNE		INTIND
	
				;NMI 
		
NMISIS		
		SEC	
		CLV
		JSR		SAVREG
		LDA		PCLR
		STA		CURAD
		LDA		PCHR
		STA		CURAD+1
		LDY		#0H
		LDA		(CURAD),Y
		JSR		OUTDAT	;SACA DATO
		BNE		GAT5
		
				;SACA PC Y TEXTO DE INTERRUPCIONES
		
INTIND	
		JSR		CLRIND                          
GAT5		
		LDA		PCLR
		LDY		PCHR
		JSR		OUTADD	;SACA PC
		JMP		STRT3 	;A ESPERA
	
				;SALVA LOS REGISTROS SALVO SI STOP EN MONITOR
	
SAVREG		
		STA		SCR1
		STX		SCR2
		STY		SCR3
		TSX	
		CLD	
		PHP	
				;SALVA BITS
		LDA		104H,X
		ADC		#0FFH
		TAY	
		LDA		105H,X
		ADC		#0FFH
		
		PLP	
		BVC		SAVRE1	;NO STOP, SALVA
		CMP		#0F0H
		BCC		SAVRE1 	;NO, SALVA
		JMP		SAVRES 	;SI, ABORTA OPERACION
SAVRE1	
		STA		PCHR
		STY		PCLR
		LDA		103H,X
		STA		PR
		LDA		102H,X
		STA		105H,X
		LDA		101H,X
		STA		104H,X
		INX	
		INX	
		INX	
		TXS	
		INX	
		INX	
		STX		SR
		LDA		SCR1
		STA		AR
		LDA		SCR2
		STA		XR 		;SALVA REGISTROS DE TEMP.
		LDA		SCR3
		STA		YR
SAVRES		
		RTS	

				;ENTRADA DE  RESET

RESET		
		LDX		#0FFH
		TXS	
		CLD	

				;INICIALIZA 65C22 I/O SISTEMA	
		
		JSR	M_PATCH2
		JMP	RES0                   
		
		
				;INICIALIZA SCRATCH	
;		
		.ORG	0FF83H
RES0 

		LDX     #29
RES1
		LDA     INTAB-1,X
		STA     BRKFLG-1,X
		STX     REST
		DEX
		BNE     RES1
		JMP     MONITR	;A BUCLE PRINCIPAL

				;SALTOS INDIRECTOS EN INTERRUPCIONES

IRQJMP
		JMP     (IRQVEC)
NMIJMP
		JMP     (NMIVEC)

				;TABLAS
				;CODIGO DE SEGMENTOS

SEGMTB
.BYTE    3FH,06H,5BH,4FH         ;0 1 2 3
.BYTE    66H,6DH,7DH,07H         ;4 5 6 7
.BYTE    7FH,6FH,77H,7CH         ;8 9 A B
.BYTE    39H,5EH,79H,71H         ;C D E F


				;TEXTOS SOBRE DISPLAY

MENTAB
.BYTE    73H,58H         ; 0 Pc
.BYTE    50H,6DH         ; 1 'rs'
.BYTE    77H,58H         ; 2 'Ac'
.BYTE    50H,64H         ; 3 'rx'
.BYTE    50H,6EH         ; 4 'rY
.BYTE    50H,73H         ; 5 'rP'
.BYTE    5FH,5EH         ; 6 'ad'
.BYTE    3DH,5CH         ; 7 'Go'
.BYTE    7CH,50H         ; 8 'br'
.BYTE    7CH,53H         ; 9 'b?'
.BYTE    3EH,5EH         ; 10 'Vd*
.BYTE    3EH,77H         ; 11 'VA'
.BYTE    10H,5EH         ; 12 'id'
.BYTE    5EH,10H         ; 13 'di'
.BYTE    5EH,71H         ; 14 dF'
.BYTE    7CH,7BH         ; 15 be'
.BYTE    10H,7BH         ; 16 'ie'
.BYTE    54H,7BH         ; 17 'ne'
.BYTE    5CH,54H         ; 18 'on'
.BYTE    5CH,71H         ; 19 'oF'
.BYTE    58H,5FH         ; 20 'ca'


					;INICIALIZACION DE SCRATCH

INTAB   .BYTE    00H,00H,00H,00H
.WORD	MONITR         ;P.C.
.BYTE   0FFH,0H,0H,0H,0H
.BYTE	04H,3DH,33H,5AH       ;DATOS DE CAS5ETE
.WORD	ERROR 	       ;SECTOR AMPLIACI0N DE FUNCIONES
.WORD	BRKSIS	       ;SECTORES DE USUARIO
.WORD	IRQSIS	       ;
.WORD	NMISIS	       ;
.WORD	IRQBRK	       ;VECTORES SECUNDARIOS
.WORD	NMIENT

		;VECTORES DE LA CPU
		
	.ORG	0FFFAH
.WORD	NMIJMP
.WORD	RESET
.WORD	IRQJMP






		.END
